//
//  ErrorCodeHelper.m
//  AsReaderScan
//
//  Created by sps on 2022/04/26.
//

#import "ErrorCodeHelper.h"
#import "ErrorCodeHelper.h"

@implementation ErrorCodeHelper


static ErrorCodeHelper *instance = nil;

+ (instancetype)sharedInstance{
   @synchronized(self) {
       if (!instance) {
           instance = [ErrorCodeHelper new];
       }
   }
   return instance;
}

#pragma mark - Private Method




- (NSString*)errorReceived:(NSData *)errorCode{
    uint8_t *pData = (uint8_t*)[errorCode bytes];
    
    NSString *strCommand = @"";
    NSString *strErrCode = @"";
    NSString *strErrTotal =@"";
    
    NSMutableString *wholeRawDate = [[NSMutableString alloc]init];
    unsigned char *bytePtr = (unsigned char *)[errorCode bytes];
    for(int i=0; i<errorCode.length; i++ ) {
        [wholeRawDate appendFormat:@"%@", [NSString stringWithFormat:@"%02X",(Byte)bytePtr[i]]];
    }
    
    
    if(errorCode.length<3){
        
        strErrTotal = [NSString stringWithFormat:  @" Unknown ErrCode : 0x%@ ",wholeRawDate];
        
    }else{
        
        //command
        switch (pData[1]) {
            case 0x01 : strCommand=@"Set Reader Power Control"; break;
            case 0x03 : strCommand=@"Get Reader Information"; break;
            case 0x06 : strCommand=@"Get Region"; break;
            case 0x07 : strCommand=@"Set Region"; break;
            case 0x08 : strCommand=@"Set System Reset"; break;
            case 0x0B : strCommand=@"Get Type C A/I Select Parameters"; break;
            case 0x0C : strCommand=@"Set Type C A/I Select Parameters"; break;
            case 0x0D : strCommand=@"Get Type C A/I Query Related Parameters"; break;
            case 0x0E : strCommand=@"Set Type C A/I Query Related Parametersv"; break;
            case 0x11 : strCommand=@"Get current RF Channel"; break;
            case 0x12 : strCommand=@"Set current RF Channel"; break;
            case 0x13 : strCommand=@"Get FH and LBT Parameters"; break;
            case 0x14 : strCommand=@"Set FH and LBT Parameters"; break;
            case 0x15 : strCommand=@"Get Tx Power Level"; break;
            case 0x16 : strCommand=@"Set Tx Power Level"; break;
            case 0x17 : strCommand=@"RF CW signal control"; break;
            case 0x22 : strCommand=@"Read Type C UII"; break;
            case 0x23 : strCommand=@"Read Type C UII RSSI"; break;
            case 0x25 : strCommand=@"Read Type C UII TID"; break;
            case 0x29 : strCommand=@"Read Type C Tag Data"; break;
            case 0x2A : strCommand=@"Read Type C Tag Long Data"; break;
            case 0x2E : strCommand=@"Get Session"; break;
            case 0x2F : strCommand=@"Set Session"; break;
            case 0x30 : strCommand=@"Get Frequency Hopping Table"; break;
            case 0x31 : strCommand=@"Set Frequency Hopping Table"; break;
            case 0x32 : strCommand=@"Get Modulation"; break;
            case 0x33 : strCommand=@"Set Modulation"; break;
            case 0x34 : strCommand=@"Get Anti-Collision Mode"; break;
            case 0x35 : strCommand=@"Set Anti-Collision Mode"; break;
            case 0x36 : strCommand=@"Start Auto Read2"; break;
            case 0x37 : strCommand=@"Stop Auto Read2"; break;
            case 0x38 : strCommand=@"Start Auto Read RSSI"; break;
            case 0x39 : strCommand=@"Stop Auto Read RSSI"; break;
            case 0x46 : strCommand=@"Write Type C Tag Data"; break;
            case 0x47 : strCommand=@"BlockWrite Type C Tag Data"; break;
            case 0x48 : strCommand=@"BlockErase Type C Tag Data"; break;
            case 0x83 : strCommand=@"BlockPermalock Type C Tag"; break;
            case 0x65 : strCommand=@"Kill/Recom Type C Tag"; break;
            case 0x82 : strCommand=@"Lock Type C Tag"; break;
            case 0xAC : strCommand=@"Antenna Check"; break;
            case 0xC5 : strCommand=@"Get RSSI"; break;
            case 0xC6 : strCommand=@"Scan RSSI"; break;
            case 0xCA : strCommand=@"Get DTC Result"; break;
            case 0xD2 : strCommand=@"Update Registry"; break;
                
            default: {
                NSString *strTem = [NSString stringWithFormat:@"0x%x",pData[1]];
                strCommand =strTem;
            }
                break;
        }
        
        //Error code
        switch (pData[2]) {
            case 0x01 : strErrCode =@"Not supported"; break;
            case 0x02 : strErrCode =@"Insufficient privileges"; break;
            case 0x03 : strErrCode =@"Memory overrun"; break;
            case 0x04 : strErrCode =@"Memory locked"; break;
            case 0x05 : strErrCode =@"Crypto suite error"; break;
            case 0x06 : strErrCode =@"Command not encapsulated"; break;
            case 0x07 : strErrCode =@"ResponseBuffer overflow"; break;
            case 0x08 : strErrCode =@"Security timeout"; break;
            case 0x0B : strErrCode =@"Insufficient power"; break;
            case 0x0F : strErrCode =@"Non-specific error"; break;
            case 0x11 : strErrCode =@"Sensor Scheduling configuration"; break;
            case 0x12 : strErrCode =@"Tag Busy"; break;
            case 0x13 : strErrCode =@"Measurement type not supported"; break;
            case 0x80 : strErrCode =@"No tag detected"; break;
            case 0x81 : strErrCode =@"Handle acquisition failure"; break;
            case 0x82 : strErrCode =@"Access password failure"; break;
            case 0x90 : strErrCode =@"CRC error"; break;
            case 0x91 : strErrCode =@"Rx Timeout"; break;
            case 0xA0 : strErrCode =@"Registry update failure"; break;
            case 0xA1 : strErrCode =@"Registry erase failure"; break;
            case 0xA2 : strErrCode =@"Registry write failure"; break;
            case 0xA3 : strErrCode =@"Registry not exist"; break;
            case 0xB0 : strErrCode =@"UART failure"; break;
            case 0xB1 : strErrCode =@"SPI failure"; break;
            case 0xB2 : strErrCode =@"I2C failure"; break;
            case 0xB3 : strErrCode =@"GPIO failure"; break;
            case 0xE0 : strErrCode =@"Not supported command"; break;
            case 0xE1 : strErrCode =@"Undefined command"; break;
            case 0xE2 : strErrCode =@"Invalid parameter"; break;
            case 0xE3 : strErrCode =@"Too high parameter"; break;
            case 0xE4 : strErrCode =@"Too low parameter"; break;
            case 0xE5 : strErrCode =@"Failure automatic read operation"; break;
            case 0xE6 : strErrCode =@"Not automatic read mode"; break;
            case 0xE7 : strErrCode =@"Failure to get last response"; break;
            case 0xE8 : strErrCode =@"Failure to control test"; break;
            case 0xE9 : strErrCode =@"Failure to reset Reader"; break;
            case 0xEA : strErrCode =@"Rfidblock control failure"; break;
            case 0xEB : strErrCode =@"Automatic read in operation"; break;
            case 0xF0 : strErrCode =@"Undefined other error"; break;
            case 0xF1 : strErrCode =@"Failure to verify write operation"; break;
            case 0xFC : strErrCode =@"Abnormal antenna"; break;
            case 0xFF : strErrCode =@"None error"; break;
                
            default: {
                NSString *strTem = [NSString stringWithFormat:@"0x%x",pData[2]];
                strErrCode =strTem;
            }
                break;
        }
        

        
      strErrTotal = [NSString stringWithFormat:  @"[ErrCode : 0x%@] \n [Cmd : %@] \n [Msg : %@]",wholeRawDate,  strCommand  ,strErrCode];
        
        
    }
    
    
    return strErrTotal;
}



@end
